/***************************************************************************
 *   Copyright (C) 2007 by David Bitseff                                   *
 *   dbitsef@zipcon.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef PALETTEEDITOR_H
#define PALETTEEDITOR_H

#include <QWidget>
#include <QFileInfoList>

#include "ui_paletteeditor.h"
#include "gradientlistmodel.h"
#include "flam3util.h"

class PaletteEditor : public QWidget, private Ui::PaletteEditor
{
	Q_OBJECT

	private:
		static const int npalettes = 701;
		flam3_palette p;
		GradientListModel m_flamPalettes;
		GradientListModel m_browsePalettes;
		QFileInfoList m_browseFileList;
		QString m_lastBrowseDir;

	public:
		PaletteEditor(QWidget* parent=0);
		void getPalette(flam3_palette);
		void setPalette(flam3_palette);
		bool loadGIMPGradient(QFileInfo&, flam3_palette);
		bool loadCPTGradient(QFileInfo&, flam3_palette);
		void setLastBrowseDir (const QString&);
		QString lastBrowseDir() const;

	signals:
		void paletteChanged();

	public slots:
		void paletteIndexChangedAction(const QModelIndex&);
		void paletteRotatedAction(int);
		void openGradientAction(bool);
		void selectGradientAction(const QModelIndex&);
		void loadPalette(int);

	protected:
		void showEvent(QShowEvent*);
		void buildPaletteSelector();
		void setPaletteView();



};

#endif
